unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Memo1KeyPress(Sender: TObject; var Key: char);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Memo1UTF8KeyPress(Sender: TObject; var UTF8Key: TUTF8Char);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  TypInfo;

function KeyToStr(Key: word; Shift: TShiftState): String;
begin
  Result :=
    'Key=' + IntToStr(Key) +
    ' Shift=' + SetToString(PTypeInfo(TypeInfo(TShiftState)), integer(Shift), true);;
end;

function StringToBytes(s: String): String;
var
  i: Integer;
begin
  Result := '';
  for i := 1 to Length(s) do
    Result := Result + Format('#%.2d', [ord(s[i])]);
end;


{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;

procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: char);
begin
  Memo1.Lines.Add('Key press: "' + char(Key) + '" (' + IntToStr(ord(Key)) + ')');
  Key := #0;
end;

procedure TForm1.Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  Memo1.Lines.Add('Key up: ' + KeyToStr(Key, Shift));
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  Memo1.Lines.Add('Key down: ' + KeyToStr(Key, Shift));
end;

procedure TForm1.Memo1UTF8KeyPress(Sender: TObject; var UTF8Key: TUTF8Char);
begin
  Memo1.Lines.Add('UTF8 Key press: "' + UTF8Key + '" (' + StringToBytes(UTF8Key) + ')');
end;

end.

